<?php
/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

class HOTLIST_MCMP_AddToHotlist extends OW_MobileComponent
{
    public function __construct()
    {
        $hotlistUser = HOTLIST_BOL_Service::getInstance()->findUserById(OW::getUser()->getId());
        
        $userInList = false;
        
        if ( $hotlistUser )
        {
            $userInList = true;
        }
        
        $this->assign("userInList", $userInList);
        
        $this->initButtons($hotlistUser);
    }
    
    protected function initButtons() 
    {
        $responderUrl = OW::getRouter()->uriForRoute('hotlist-add-remove-responder');
        
        $script = new UTIL_JsGenerator();
        
        $script->addScript("
                ; var prepareResult = function(data) { 
                      if ( !data )
                      {
                        return;
                      }

                      if ( (data.added == 1 ||  data.removed == 1) && window.mobileUserList )
                      {
                          window.mobileUserList.allowLoadData = true;
                          window.mobileUserList.process = false;
                          window.mobileUserList.renderedItems = [];

                          $(window.mobileUserList.node + \" .owm_content_list_item\").remove();

                          window.mobileUserList.loadData();

                          if ( data.message )
                          {
                            OWM.info(data.message);
                          }
                          
                          var addButton = $('.hotlist_add_button').parents('div.hotlist_buttons');
                          var removeButton = $('.hotlist_remove_button').parents('div.hotlist_buttons');
                          
                          if ( data.added == 1 )
                          {
                            addButton.hide();
                            removeButton.show();
                          }
                          
                          if ( data.removed == 1 )
                          {
                            addButton.show();
                            removeButton.hide();
                          }
                      }
                      else if ( data.error )
                      {
                          OWM.ajaxFloatBox('HOTLIST_MCMP_Notification', [data.error], {});
                      } 
                }
            ");
        
        $script->addScript("; $('.hotlist_add_button input').on('click', function() { 
            $.ajax({
                url: {\$responderUrl},
                type: 'POST',
                data: {'add_to_list': 'true'},
                dataType: 'json'
            }).done(function( data ) {
                prepareResult(data);

            });
        } );", array('responderUrl' => $responderUrl));
        
        $script->addScript("; $('.hotlist_remove_button input').on('click', function() { 
            $.ajax({
                url: {\$responderUrl},
                type: 'POST',
                data: {'remove_from_list': 'true'},
                dataType: 'json'
            }).done(function( data ) {
                prepareResult(data);
                
            }  ); } );  ", array('responderUrl' => $responderUrl));
        
        OW::getDocument()->addOnloadScript($script->generateJs());
    }
}