<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

OW::getLanguage()->importPluginLangs(__DIR__ . DS . 'langs.zip', 'protectedphotos', true);

if ( !OW::getPluginManager()->isPluginActive('photo') )
{
    OW::getFeedback()->warning(OW::getLanguage()->text('protectedphotos', 'install_error'));
    BOL_PluginService::getInstance()->uninstall('protectedphotos');

    throw new RedirectException(OW::getRouter()->urlForRoute('admin_plugins_installed'));
}

$sqls = array(
    'CREATE TABLE IF NOT EXISTS `' . OW_DB_PREFIX . 'protectedphotos_passwords` (
  `id` int(10) unsigned NOT NULL,
  `albumId` int(10) unsigned NOT NULL,
  `privacy` varchar(128) NOT NULL,
  `meta` text,
  `password` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;',

    'ALTER TABLE `' . OW_DB_PREFIX . 'protectedphotos_passwords` ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `albumId` (`albumId`);',

    'ALTER TABLE `' . OW_DB_PREFIX . 'protectedphotos_passwords` MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;',

    'ALTER TABLE `' . OW_DB_PREFIX . 'protectedphotos_passwords` ADD KEY `privacy` (`privacy`)',

    'CREATE TABLE IF NOT EXISTS `' . OW_DB_PREFIX . 'protectedphotos_accesses` (
  `id` int(10) unsigned NOT NULL,
  `passwordId` int(10) unsigned NOT NULL,
  `userId` int(10) unsigned NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;',

    'ALTER TABLE `' . OW_DB_PREFIX . 'protectedphotos_accesses` ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `passwordId` (`passwordId`,`userId`);',

    'ALTER TABLE `' . OW_DB_PREFIX . 'protectedphotos_accesses` MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;'
);

foreach ( $sqls as $sql )
{
    try
    {
        OW::getDbo()->query($sql);
    }
    catch ( Exception $e )
    {
        OW::getLogger('protected_photos.install')->addEntry(json_encode($e));
    }
}
