<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.
 * Pass on to others in any form are not permitted provided.
 * Sale are not permitted provided.
 * Sale this product are not permitted provided.
 * Gift this product are not permitted provided.
 * This plugin should be bought from the developer by paying money to PayPal account: biuro@grafnet.pl
 * Legal purchase is possible only on the official website URL: http://www.oxdate.org/
 * Modyfing of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Modifying source code, all information like: copyright must remain.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

class USEARCH_CLASS_AgeRangeValidator extends OW_Validator
{
    private $from;

    private $to;

    public function __construct( $from, $to )
    {
        $this->from = $from;
        $this->to = $to;

        $this->setErrorMessage(OW::getLanguage()->text('usearch', 'age_range_incorrect'));
    }

    public function isValid( $value )
    {
        if ( !isset($value['from']) || !isset($value['to']) )
        {
            return false;
        }

        if ( (int) $value['from'] < $this->from || (int) $value['from'] > $this->to )
        {
            return false;
        }

        if ( (int) $value['to'] < $this->from || (int) $value['to'] > $this->to )
        {
            return false;
        }

        if ( (int) $value['from'] > (int) $value['to'] )
        {
            return false;
        }

        return true;
    }

    public function getJsValidator()
    {
        $js = "{
            validate : function( value ){
                if ( value.from == undefined || value.to == undefined )
                {
                    throw " . json_encode($this->getError()) . "; return;
                }
                if ( parseInt(value.from) < ".$this->from." || parseInt(value.from) > ".$this->to." )
                {
                    throw " . json_encode($this->getError()) . "; return;
                }
                if ( parseInt(value.to) < ".$this->from." || parseInt(value.to) > ".$this->to." )
                {
                    throw " . json_encode($this->getError()) . "; return;
                }

                if ( parseInt(value.from) > parseInt(value.to) )
                {
                    throw " . json_encode($this->getError()) . "; return;
                }
            },
            getErrorMessage : function(){ return " . json_encode($this->getError()) . " }
        }";

        return $js;
    }
}